OPT MODULE, PREPROCESS
OPT EXPORT

-> EOR clashes with Assembly mnemonic
-> NOP clashes with Assembly mnemonic
-> DO clashes with E keyword
ENUM XEOF=236, SUSP, ABORT, XEOR, SE, XNOP, DM, BREAK, IP, AO, AYT, EC, EL,
     GA, SB, WILL, WONT, XDO, DONT, IAC

CONST SYNCH=242

DEF telcmds:PTR TO LONG,
    telopts:PTR TO LONG,
    slc_names:PTR TO LONG,
    authtype_names:PTR TO LONG,
    encrypt_names:PTR TO LONG,
    enctype_names:PTR TO LONG

#define _telcmds ['EOF','SUSP','ABORT','EOR','SE','NOP','DMARK','BRK','IP', \
                  'AO','AYT','EC','EL','GA','SB','WILL','WONT','DO','DONT', \
                  'IAC',NIL]

CONST TELCMD_FIRST=XEOF,
      TELCMD_LAST=IAC

#define TELCMD_OK(x) (((x)<=TELCMD_LAST) AND ((x)>=TELCMD_FIRST))
#define TELCMD(x) (telcmds[(x)-TELCMD_FIRST])

ENUM TELOPT_BINARY, TELOPT_ECHO, TELOPT_RCP, TELOPT_SGA, TELOPT_NAMS,
     TELOPT_STATUS, TELOPT_TM, TELOPT_RCTE, TELOPT_NAOL, TELOPT_NAOP,
     TELOPT_NAOCRD, TELOPT_NAOHTS, TELOPT_NAOHTD, TELOPT_NAOFFD,
     TELOPT_NAOVTS, TELOPT_NAOVTD, TELOPT_NAOLFD, TELOPT_XASCII,
     TELOPT_LOGOUT, TELOPT_BM, TELOPT_DET, TELOPT_SUPDUP,
     TELOPT_SUPDUPOUTPUT, TELOPT_SNDLOC, TELOPT_TTYPE, TELOPT_EOR,
     TELOPT_TUID, TELOPT_OUTMRK, TELOPT_TTYLOC, TELOPT_3270REGIME,
     TELOPT_X3PAD, TELOPT_NAWS, TELOPT_TSPEED, TELOPT_LFLOW,
     TELOPT_LINEMODE, TELOPT_XDISPLOC, TELOPT_ENVIRON,
     TELOPT_AUTHENTICATION, TELOPT_ENCRYPT, TELOPT_EXOPL=255

CONST NTELOPTS=1+TELOPT_ENCRYPT

#define _telopts ['BINARY','ECHO','RCP','SUPPRESS GO AHEAD','NAME','STATUS', \
                  'TIMING MARK','RCTE','NAOL','NAOP','NAOCRD','NAOHTS', \
                  'NAOHTD','NAOFFD','NAOVTS','NAOVTD','NAOLFD','EXTEND ASCII', \
                  'LOGOUT','BYTE MACRO','DATA ENTRY TERMINAL','SUPDUP', \
                  'SUPDUP OUTPUT','SEND LOCATION','TERMINAL TYPE', \
                  'END OF RECORD','TACACS UID','OUTPUT MARKING','TTYLOC', \
                  '3270 REGIME','X.3 PAD','NAWS','TSPEED','LFLOW','LINEMODE', \
                  'XDISPLOC','ENVIRON','AUTHENTICATION','ENCRYPT',NIL]

CONST TELOPT_FIRST=TELOPT_BINARY,
      TELOPT_LAST=TELOPT_ENCRYPT

#define TELOPT_OK(x) (((x)<=TELOPT_LAST) AND ((x)>=TELOPT_FIRST))
#define TELOPT(x) (telopts[(x)-TELOPT_FIRST])

ENUM TEQUAL_IS, TELQUAL_SEND, TELQUAL_INFO, TELQUAL_REPLY=2, TELQUAL_NAME

ENUM LM_MODE=1, LM_FORWARDMASK, LM_SLC

SET MODE_EDIT, MODE_TRAPSIG, MODE_ACK, MODE_SOFT_TAB, MODE_LIT_ECHO

CONST MODE_MASK=$1F

CONST MODE_FLOW=$0100,
      MODE_ECHO=$0200,
      MODE_INBIN=$0400,
      MODE_OUTBIN=$0800,
      MODE_FORCE=$1000

ENUM SLC_SYNCH=1, SLC_BRK, SLC_IP, SLC_AO, SLC_AYT, SLC_EOR, SLC_ABORT,
     SLC_EOF, SLC_SUSP, SLC_EC, SLC_EL, SLC_EW, SLC_RP, SLC_LNEXT,
     SLC_XON, SLC_XOFF, SLC_FORW1, SLC_FORW2

CONST NSLC=18

#define SLC_NAMELIST '0','SYNCH','BRK','IP','AO','AYT','EOR', \
                     'ABORT','EOF','SUSP','EC','EL','EW','RP', \
                     'LNEXT','XON','XOFF','FORW1','FORW2',NIL

#define _slc_names [SLC_NAMELIST]
#define SLC_NAMES SLC_NAMELIST

#define SLC_NAME_OK(x) (((x)>=0) AND ((x)<NSLC))
#define SLC_NAME(x) (slc_names[(x)])

ENUM SLC_NOSUPPORT, SLC_CANTCHANGE, SLC_VARIABLE, SLC_DEFAULT, SLC_LEVELBITS=3

ENUM SLC_FUNC, SLC_FLAGS, SLC_VALUE

CONST SLC_ACK=$80, SLC_FLUSHIN=$40, SLC_FLUSHOUT=$20

ENUM ENV_VALUE, ENV_VAR, ENV_ESC

ENUM AUTH_WHO_CLIENT, AUTH_WHO_SERVER, AUTH_WHO_MASK=1

CONST AUTH_HOW_ONE_WAY=0, AUTH_HOW_MUTUAL=2, AUTH_HOW_MASK=2

ENUM AUTHTYPE_NULL, AUTHTYPE_KERBEROS_V4, AUTHTYPE_KERBEROS_V5, AUTHTYPE_SPX,
     AUTHTYPE_MINK, AUTHTYPE_CNT

CONST AUTHTYPE_TEST=99

#define _authtype_names ['NULL','KERBEROS_V4','KERBEROS_V5','SPX','MINK',NIL]

#define AUTHTYPE_NAME_OK(x) (((x)>=0) AND ((x)<AUTHTYPE_CNT))
#define AUTHTYPE_NAME(x) (authtype_names[(x)])

ENUM ENCRYPT_IS, ENCRYPT_SUPPORT, ENCRYPT_REPLY, ENCRYPT_START, ENCRYPT_END,
     ENCRYPT_REQSTART, ENCRYPT_REQEND, ENCRYPT_ENC_KEYID, ENCRYPT_DEC_KEYID,
     ENCRYPT_CNT

ENUM ENCTYPE_ANY, ENCTYPE_DES_CFB64, ENCTYPE_DES_OFB64, ENCTYPE_CNT

#define _encrypt_names ['IS','SUPPORT','REPLY','START','END','REQUEST-START', \
                        'REQUEST-END','ENC-KEYID','DEC-KEYID',NIL]

#define _enctype_names ['ANY','DES_CFB64','DES_OFB64',NIL]

#define ENCRYPT_NAME_OK(x) (((x)>=0) AND ((x)<ENCRYPT_CNT))
#define ENCRYPT_NAME(x) (encrypt_names[(x)])

#define ENCTYPE_NAME_OK(x) (((x)>=0) AND ((x)<ENCTYPE_CNT))
#define ENCTYPE_NAME(x) (enctype_names[(x)])

PROC telnet_init_names()
  IF telcmds=NIL
    telcmds:=_telcmds
    telopts:=_telopts
    slc_names:=_slc_names
    authtype_names:=_authtype_names
    encrypt_names:=_encrypt_names
    enctype_names:=_enctype_names
  ENDIF
ENDPROC
