OPT MODULE
OPT EXPORT

MODULE 'devices/timer',
       'exec/io',
       'utility/tagitem'

CONST SANA2_MAX_ADDR_BITS=128,
      SANA2_MAX_ADDR_BYTES=16

OBJECT iosana2req
  req:io
  wireerror
  packettype
  srcaddr[SANA2_MAX_ADDR_BYTES]:ARRAY
  dstaddr[SANA2_MAX_ADDR_BYTES]:ARRAY
  datalength
  data
  statdata
  buffermanagement
ENDOBJECT

CONST SANA2IOB_RAW=7,
      SANA2IOF_RAW=128,
      SANA2IOB_BCAST=6,
      SANA2IOF_BCAST=64,
      SANA2IOB_MCAST=5,
      SANA2IOF_MCAST=32,
      SANA2IOB_QUICK=IOB_QUICK,
      SANA2IOF_QUICK=IOF_QUICK

CONST SANA2OPB_MINE=0,
      SANA2OPF_MINE=1,
      SANA2OPB_PROM=1,
      SANA2OPF_PROM=2

CONST S2_DUMMY=TAG_USER+$B0000

CONST S2_COPYTOBUFF=S2_DUMMY+1,
      S2_COPYFROMBUFF=S2_DUMMY+2,
      S2_PACKETFILTER=S2_DUMMY+3

OBJECT sana2devicequery
  sizeavailable
  sizesupplied
  devqueryformat
  devicelabel
  addrfieldsize:INT
  mtu
  bps
  hardwaretype
ENDOBJECT

CONST S2WIRETYPE_ETHERNET=1,
      S2WIRETYPE_IEEE802=6,
      S2WIRETYPE_ARCNET=7,
      S2WIRETYPE_LOCALTALK=11,
      S2WIRETYPE_DYLAN=12,
      S2WIRETYPE_AMOKNET=200,
      S2WIRETYPE_LIANA=202,
      S2WIRETYPE_PPP=253,
      S2WIRETYPE_SLIP=254,
      S2WIRETYPE_CSLIP=255,
      S2WIRETYPE_PLIP=420

OBJECT sana2packettypestats
  packetssent
  packetsreceived
  bytessent
  bytesreceived
  packetsdropped
ENDOBJECT

OBJECT sana2specialstatrecord
  type
  count
  string:PTR TO CHAR
ENDOBJECT

OBJECT sana2specialstatheader
  recordcountmax
  recordcountsupplied
ENDOBJECT

OBJECT sana2devicestats
  packetsreceived
  packetssent
  baddata
  overruns
  unused
  unknowntypesreceived
  reconfigurations
  laststart:timeval
ENDOBJECT

CONST S2_START=CMD_NONSTD

CONST S2_DEVICEQUERY=S2_START+0,
      S2_GETSTATIONADDRESS=S2_START+1,
      S2_CONFIGINTERFACE=S2_START+2,
      S2_ADDMULTICASTADDRESS=S2_START+5,
      S2_DELMULTICASTADDRESS=S2_START+6,
      S2_MULTICAST=S2_START+7,
      S2_BROADCAST=S2_START+8,
      S2_TRACKTYPE=S2_START+9,
      S2_UNTRACKTYPE=S2_START+10,
      S2_GETTYPESTATS=S2_START+11,
      S2_GETSPECIALSTATS=S2_START+12,
      S2_GETGLOBALSTATS=S2_START+13,
      S2_ONEVENT=S2_START+14,
      S2_READORPHAN=S2_START+15,
      S2_ONLINE=S2_START+16,
      S2_OFFLINE=S2_START+17,
      S2_END=S2_START+18

ENUM S2ERR_NO_ERROR, S2ERR_NO_RESOURCES,
     S2ERR_BAD_ARGUMENT=3, S2ERR_BAD_STATE, S2ERR_BAD_ADDRESS,
     S2ERR_MTU_EXCEEDED, S2ERR_NOT_SUPPORTED=8, S2ERR_SOFTWARE,
     S2ERR_OUTOFSERVICE, S2ERR_TX_FAILURE

ENUM S2WERR_GENERIC_ERROR, S2WERR_NOT_CONFIGURED, S2WERR_UNIT_ONLINE,
     S2WERR_UNIT_OFFLINE, S2WERR_ALREADY_TRACKED, S2WERR_NOT_TRACKED,
     S2WERR_BUFF_ERROR, S2WERR_SRC_ADDRESS, S2WERR_DST_ADDRESS,
     S2WERR_BAD_BROADCAST, S2WERR_BAD_MULTICAST, S2WERR_MULTICAST_FULL,
     S2WERR_BAD_EVENT, S2WERR_BAD_STATDATA, S2WERR_IS_CONFIGURED,
     S2WERR_NULL_POINTER, S2WERR_TOO_MANY_RETRIES, S2WERR_RCVEL_HDW_ERR

SET S2EVENT_ERROR, S2EVENT_TX, S2EVENT_RX, S2EVENT_ONLINE,
    S2EVENT_OFFLINE, S2EVENT_BUFF, S2EVENT_HARDWARE, S2EVENT_SOFTWARE
